/** Panel which contains the options for the objects to be 
    painted in RobotPanel for Assignment P.
    @author Carey Fry and Dan Kelly
		@version 1.0
*/

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class ListPanel extends JPanel implements ListSelectionListener {

// Declare and initalize necessary values
  private static String[] colorListString = {"Pink", "Green", "Orange"},
			                    sizeListString = {"Small", "Medium", "Large"},
			                    shapeListString = {"Rectangle", "Triangle", "Circle", "FirstObject",
					                                 "SecondObject", "ThirdObject"};

  private static String color= "Pink", shape = "Rectangle", size ="Small";


  private static Polygon polygon;

	
  private JList shapeList = new JList(shapeListString), 
	              sizeList = new JList(sizeListString), 
		            colorList = new JList(colorListString);
		
  private JButton makeButton, deleteButton;
  private JLabel shapeLabel, colorLabel, sizeLabel;
	private RobotPanel robotPanel;


/** Sets the background color, adds lists to choise the color shape and
type of the objects to be detected, adds a Make and Delete button, and
labels the lists */

    public ListPanel (RobotPanel rp) {
		
	    setBackground(Color.darkGray);
	
  	  JLabel shapeLabel = new JLabel("Object Shape");
	    JLabel colorLabel = new JLabel("Object Color");
	    JLabel sizeLabel = new JLabel("Object Size");

// Adds the list of shapes	
    	add(shapeLabel);
	
	    shapeList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	    //JScrollPane shapeScroll = new JScrollPane(shapeList);
	    shapeList.setVisibleRowCount(3);
	    add(shapeList);
	    //add(shapeScroll);
	    shapeList.addListSelectionListener(this);

// Adds the lists of sizes	
    	add(sizeLabel);
	    add(sizeList);
	    sizeList.addListSelectionListener(this);
	
// Adds the list of colors
    	add(colorLabel);
	    add(colorList);
	    colorList.addListSelectionListener(this);

// Adds the MAKE and DELETE buttons	
  	  makeButton = new JButton("Make Object");
	    makeButton.addActionListener(new ButtonListener());
      add(makeButton);
	    deleteButton = new JButton("Delete Objects");
	    deleteButton.addActionListener(new ButtonListener());
      add(deleteButton);
			
			robotPanel = rp;
	  }

/** This method is invoked every time the panel is repainted. It should
not be invoked directly */
    public void paintComponent (Graphics g) {
	    	super.paintComponent(g);
  	}

// *****************************************************


/**  When a valus on the list is changed, this method listens to the list
and changes the value of shape, size, and color */

    public void valueChanged(ListSelectionEvent evt) {
	
    	JList sourceList = (JList)evt.getSource();

    	String listString;
	
	    Object[] values = sourceList.getSelectedValues();

	    listString = (String)values[0];
	
	    if (sourceList == shapeList) {
		    shape = listString;
		  }
	    if (sourceList == sizeList) {
		    size = listString;
		  }
	    if (sourceList == colorList) {
		    color = listString;
		  }
	  }

// ****************************************************

/** Returns the color selected */
  public static String getColorString() {
  	return(color);
	}
/** Returns the size of the string */
  public static String getSizeString() {
	  return(size);
	}
/** Returns the shape selected */
  public static String getShapeString() {
  	return(shape);
	}
/** Returns a polugon */
  public static Polygon getShape() {
	  return(polygon);
	}
	
// ********************************************************

/** This method creats the polygon from the inforamion entered in the
lists */
	private void makeShape() {

	  if (shape.equals("Rectangle")) {
		  RectangleObject rectangle = new RectangleObject(size, color);
		  polygon = rectangle.GetObject();
		}

	  if (shape.equals("Triangle")) {
		  TriangleObject triangle = new TriangleObject(size, color);
		  polygon = triangle.GetObject();
		}

  	if (shape.equals("Circle")) {
	  	OvalObject oval = new OvalObject(size, color);
	  	polygon = oval.GetObject();
		}

	  if (shape.equals("FirstObject")) {
		  FirstObject first = new FirstObject(size, color);
		  polygon = first.GetObject();
		}
	
	  if (shape.equals("SecondObject")) {
	  	SecondObject second = new SecondObject(size, color);
		  polygon = second.GetObject();
		}

	  if (shape.equals("ThirdObject")) {
	  	ThirdObject third = new ThirdObject(size, color);
		  polygon = third.GetObject();
		}
  }

// *****************************************************

/** Listens to the buttons. This adds an object and deletes all
objects from the panel */
  class ButtonListener implements ActionListener {
    public void actionPerformed(ActionEvent evt) {
      JButton source = (JButton)evt.getSource();
        if (source == makeButton) {
// When the MAKE button is pressed, this creats an object 
          polygon = new Polygon();
          makeShape();		// returns selected polygon
		robotPanel.setArrays(polygon,color);
        } // END if
// When the DELETE button is pressed, this delete all the objects
      	if (source == deleteButton) { 
		robotPanel.resetNumberOfPolygons();
        } // END if
    } // END actionPerformed
  } // END ButtonListener

}
