/** Panel which contains the sliders for the radius of the 
    robot and the robot's sensor area for Assignment P.
    @author Jennifer Pitts and Dan Kelly
		@version 1.0
*/

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;

public class RadPanel extends JPanel {

	private RobotPanel robotPanel;
/** Sets the background color and andd one slider to control the radius
of the robot and another slider to changes the radius of the sensor */
  public RadPanel (RobotPanel rp) {

// This Slider determins the radius of the Robot
    JSlider Rslider = new JSlider(JSlider.HORIZONTAL,5,20,13);
    Rslider.addChangeListener(new RSliderListener());
    Rslider.setMajorTickSpacing(5);
		Rslider.setMinorTickSpacing(1);
    Rslider.setPaintTicks(true);
    Hashtable RlabelTable = new Hashtable();
    RlabelTable.put( new Integer(13), new JLabel("Robot Radius"));
    Rslider.setLabelTable(RlabelTable);
    Rslider.setPaintLabels(true);
    Rslider.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));

// This Slider determins the radius of the Sensor
    JSlider Cslider = new JSlider(JSlider.HORIZONTAL,25,60,42);
    Cslider.addChangeListener(new CSliderListener());
    Cslider.setMajorTickSpacing(5);
		Cslider.setMinorTickSpacing(1);
    Cslider.setPaintTicks(true);
    Hashtable ClabelTable = new Hashtable();
    ClabelTable.put( new Integer(30), new JLabel("Sensor Radius"));
    Cslider.setLabelTable(ClabelTable);
    Cslider.setPaintLabels(true);
    Cslider.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
    		
    add(Rslider);
    add(Cslider);
		setBackground(Color.red);
		robotPanel = rp;  
  }

/** This method is invoked eact time the panel is repainted. You should
never invoke it directly */
  public void paintComponent(Graphics g) {
  	super.paintComponent(g);
  }

  /** Listens to the Rslider. */
  class RSliderListener implements ChangeListener {
    public void stateChanged(ChangeEvent e) {
      JSlider source = (JSlider)e.getSource();
      Robot r = robotPanel.getRobot();
/** Changes the radius of the Robot */
	if(source.getValueIsAdjusting()) {
		r.setRobotRadius((int)source.getValue());
		robotPanel.paintMe();
	} // END if
    } // END stateChanged
  } // END RSliderListener

  /** Listens to the Cslider. */
  class CSliderListener implements ChangeListener {
    public void stateChanged(ChangeEvent e) {
      JSlider source = (JSlider)e.getSource();
      Robot r = robotPanel.getRobot();
/** Changes the radius of the Sensor */
	if(source.getValueIsAdjusting()) {
		r.setSensorRadius((int)source.getValue());
		robotPanel.paintMe();
	} // END if
    } // END stateChanged
  } // END CSliderListener
		
} // END ButtonPanel
