/** Frame for Assignment P
    @author Dan Kelly
		@version 1.0
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class RobotFrame extends JFrame {

  /** Set the frame in the middle of the screen.  The frame is 
	    three quarters the size of the screen.  It contains one 
			instance each of RobotPanel, ButtonPanel, and ListPanel. */
  public RobotFrame () {

    // Set the title to "Robot"
    setTitle("Robot");
    
    // Get the toolkit and dimension so the screen size can be received 
		Toolkit tk = Toolkit.getDefaultToolkit();
    Dimension d = tk.getScreenSize();
    int screenWidth = d.width;
    int screenHeight = d.height;
		
    setSize((3*screenWidth)/4,(3*screenHeight)/4);  // Set the frame size to half the screen
    setLocation(screenWidth/8,screenHeight/8);  // Set frame in the middle of the screen
		
    // Close when the X is clicked
		addWindowListener(new WindowAdapter()
      {public void windowClosing (WindowEvent e)
        {System.exit(0);}});
				
    RobotPanel robotPanel=new RobotPanel();  // Create a new RobotPanel
    ButtonPanel buttonPanel=new ButtonPanel(robotPanel);  // Create a new ButtonPanel
    RadPanel radPanel=new RadPanel(robotPanel);  // Create a new ButtonPanel
		ListPanel listPanel=new ListPanel(robotPanel);  // Create a new ListPanel
		radPanel.setLayout(new FlowLayout(FlowLayout.CENTER));  // Set the layout of radPanel
    buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));  // Set the layout of buttonPanel
		listPanel.setLayout(new BoxLayout(listPanel,BoxLayout.Y_AXIS));  // Set the layout of listenPanel
    Container container=getContentPane();  // Define a container equal to the content pane
    container.setLayout(new BorderLayout());  // Set the layout of the container
    container.add(robotPanel,BorderLayout.CENTER);  // Add the robotPanel to the center of the container
    container.add(buttonPanel,BorderLayout.SOUTH);  // Add the buttonPanel to the south of the container
    container.add(radPanel,BorderLayout.NORTH);  // Add the buttonPanel to the north of the container
		container.add(listPanel,BorderLayout.EAST);  // Add the listPanel to the east of the container
  } // END Constructor
} // END RobotFrame


